﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Localization;
using Microsoft.JSInterop;
using myBlazorApp.Models;
using myBlazorApp.Services;
namespace myBlazorApp.Components
{
    public partial class MyInventory
    {
        [Parameter]
        public List<InventoryListItem> ItemsInventory { get; set; }

        public int index { get; set; } = 0;

        public ObservableCollection<InventoryAction> Actions { get; set; }

        public string CurrentDragItem { get; set; }
        public int CurrentDragIndex { get; set; }
        public int CurrentDragNumber { get; set; }
        public int CurrentDragStackSize { get; set; }
        public InventoryItem CurrentInventoryItem {get; set;} = new InventoryItem();

        public MyInventory()
        {
            Actions = new ObservableCollection<InventoryAction>();
            Actions.CollectionChanged += OnActionsCollectionChanged;
            
        }

        [Inject]
        public IDataService DataService { get; set; }

        [Inject]
        public IStringLocalizer<MyInventory> Localizer { get; set; }

        [Inject]
        public IWebHostEnvironment WebHostEnvironment { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }

        [Inject]
        internal IJSRuntime JavaScriptRuntime { get; set; }

        private async void OnActionsCollectionChanged(object? sender, NotifyCollectionChangedEventArgs e)
        {
            JavaScriptRuntime.InvokeVoidAsync("MyInventory.AddActions", e.NewItems);
            if (this.Actions.Last().Action == "End" || this.Actions.Last().Action == "Drop" || this.Actions.Last().Action == "Start")
            {
                    string[] infos = new string[] { this.Actions.Last().ItemName, this.Actions.Last().Index.ToString(), this.Actions.Last().Number.ToString(), this.Actions.Last().StackSize.ToString() };
                    await DataService.UpdateInventory(infos);      
            }     
        }
    }
}

